// file My.h
// author Edda Nourbakhsh


#pragma once


#ifdef My_EXPORTS
#define My_API __declspec(dllexport)
#else
#define My_API __declspec(dllimport)
#endif

#define PtrSegmentName "MyPtrSegment"



#include <windows.h>
#include <iostream>
#include <vector>
#include <sstream>
#include <string>
#include "SharedMemoryPtrGuard.h"


class My;


extern "C" My_API My * Init(char const * name);


class My
{

public:
	My(char const * name)
		: mName(name)
		, mPtrGuard(
			SharedMemoryName,
			PtrSegmentName,
			this
			)
	{
	}

public:
	virtual ~My()
	{
	}

public:
	void SayHello()
	{
		My * myInSharedMemory = *(mPtrGuard.get());
		if (myInSharedMemory != nullptr)
			std::cout << myInSharedMemory->getText() << mName.c_str() << "." << std::endl;
		else
			std::cout << "Hello, it's me: " << mName.c_str() << ". I could not get instance from shared memeory." << std::endl;
	}

public:
	std::string getText()
	{
		std::stringstream s;
		s << "Hello, I am " << mName.c_str() << ". Greeting you via ";

		std::string str(s.str().c_str());

		return str;
	}

public:
	void destroy()
	{
		mInstances.clear();
	}

public:
	static std::vector< std::shared_ptr < My > > mInstances;

private:
	std::string mName;
	SharedMemoryPtrGuard< My * > mPtrGuard;


};
