// file main.cpp
// author Edda Nourbakhsh


#include "../../MyDll/src/My.h"


typedef My * (*Signature)(char const * name);

int main(int argc, char* argv[])
{
	LPCTSTR dllPath("MyDll.dll");
	HINSTANCE hinstLib1;
	HINSTANCE hinstLib2;

	// Get a handle to the DLL module.
	if (hinstLib1 = LoadLibrary(dllPath))
	{
		Signature init1 = reinterpret_cast<Signature>(GetProcAddress(hinstLib1, "Init"));
		My * pMy1 = init1("instance1");

		if (hinstLib2 = LoadLibrary(dllPath))
		{
			Signature init2 = reinterpret_cast<Signature>(::GetProcAddress(hinstLib2, "Init"));
			My * pMy2 = init2("instance2");

			pMy1->SayHello();
			pMy2->SayHello();
		}
		else
		{
			FreeLibrary(hinstLib2);
		}
		FreeLibrary(hinstLib1);
	}
	else
	{
	}

	system("pause");

	return 0;
}
